Index: issm/trunk/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 27232)
@@ -7036,242 +7194,4 @@
 }
 /*}}}*/
-void       Tria::SealevelchangeGeometrySubElementKernel(SealevelGeometry* slgeom){ /*{{{*/
-
-	/*Declarations:{{{*/
-	int nel;
-	IssmDouble planetarea,planetradius;
-	IssmDouble constant,ratioe;
-	IssmDouble rho_earth;
-	IssmDouble lati,longi;
-	IssmDouble latitude[NUMVERTICES];
-	IssmDouble longitude[NUMVERTICES];
-	IssmDouble x,y,z,dx,dy,dz,N_azim,E_azim;
-	IssmDouble xyz_list[NUMVERTICES][3];
-
-	#ifdef _HAVE_RESTRICT_
-	IssmDouble* __restrict__ G_viscoelastic_precomputed=NULL;
-	IssmDouble* __restrict__ G_gravi_precomputed=NULL;
-	IssmDouble* __restrict__ U_viscoelastic_precomputed=NULL;
-	IssmDouble* __restrict__ H_viscoelastic_precomputed=NULL;
-	IssmDouble** __restrict__ Gsubel=NULL;
-	IssmDouble** __restrict__ GUsubel=NULL;
-	IssmDouble** __restrict__ GNsubel=NULL;
-	IssmDouble** __restrict__ GEsubel=NULL;
-
-	#else
-	IssmDouble* G_viscoelastic_precomputed=NULL;
-	IssmDouble* G_gravi_precomputed=NULL;
-	IssmDouble* U_viscoelastic_precomputed=NULL;
-	IssmDouble* H_viscoelastic_precomputed=NULL;
-	IssmDouble** Gsubel=NULL;
-	IssmDouble** GUsubel=NULL;
-	IssmDouble** GNsubel=NULL;
-	IssmDouble** GEsubel=NULL;
-	#endif
-
-	/*viscoelastic green function:*/
-	int index;
-	int M;
-	IssmDouble doubleindex,lincoef;
-
-	/*Computational flags:*/
-	bool computeselfattraction = false;
-	bool computeelastic = false;
-	bool computeviscous = false;
-	int  horiz;
-	int grd, grdmodel;
-
-	bool istime=true;
-	IssmDouble timeacc=0;
-	IssmDouble start_time,final_time;
-	int  nt,precomputednt;
-
-	/*}}}*/
-	/*Recover parameters:{{{ */
-	rho_earth=FindParam(MaterialsEarthDensityEnum);
-	this->parameters->FindParam(&computeselfattraction,SolidearthSettingsSelfAttractionEnum);
-	this->parameters->FindParam(&computeelastic,SolidearthSettingsElasticEnum);
-	this->parameters->FindParam(&computeviscous,SolidearthSettingsViscousEnum);
-	this->parameters->FindParam(&nel,MeshNumberofelementsEnum);
-	this->parameters->FindParam(&planetarea,SolidearthPlanetAreaEnum);
-	this->parameters->FindParam(&planetradius,SolidearthPlanetRadiusEnum);
-	this->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
-	this->parameters->FindParam(&grd,SolidearthSettingsGRDEnum); 
-	this->parameters->FindParam(&grdmodel,GrdModelEnum);
-	/*}}}*/
-
-	/*early return:*/
-	if (!grd || grdmodel!=ElasticEnum) return; //Love numbers won't be found in this case, return before loading them
-	if(!computeselfattraction)return;
-
-	/*Recover precomputed green function kernels:{{{*/
-	DoubleVecParam* parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeGSelfAttractionEnum)); _assert_(parameter);
-	parameter->GetParameterValueByPointer((IssmDouble**)&G_gravi_precomputed,&M);
-
-	if(computeelastic){
-		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeGViscoElasticEnum)); _assert_(parameter);
-		parameter->GetParameterValueByPointer((IssmDouble**)&G_viscoelastic_precomputed,NULL);
-
-		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeUViscoElasticEnum)); _assert_(parameter);
-		parameter->GetParameterValueByPointer((IssmDouble**)&U_viscoelastic_precomputed,NULL);
-
-		if(horiz){
-			parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeHViscoElasticEnum)); _assert_(parameter);
-			parameter->GetParameterValueByPointer((IssmDouble**)&H_viscoelastic_precomputed,NULL);
-
-		}
-	}
-	/*}}}*/
-	/*Compute lat long of all vertices in the element:{{{*/
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-	for(int i=0;i<NUMVERTICES;i++){
-		latitude[i]= asin(xyz_list[i][2]/planetradius);
-		longitude[i]= atan2(xyz_list[i][1],xyz_list[i][0]);
-	}
-	/*}}}*/
-	/*Compute green functions:{{{ */
-	constant=3/rho_earth/planetarea;
-
-	if(computeviscous){
-		this->parameters->FindParam(&istime,LoveIsTimeEnum);
-		if(!istime)_error_("Frequency love numbers not supported yet!");
-		this->parameters->FindParam(&timeacc,SolidearthSettingsTimeAccEnum);
-		this->parameters->FindParam(&start_time,TimesteppingStartTimeEnum);
-		this->parameters->FindParam(&final_time,TimesteppingFinalTimeEnum);
-		nt=reCast<int,IssmDouble>((final_time-start_time)/timeacc)+1;
-	}
-	else{
-		nt=1; //in elastic, or if we run only selfattraction, we need only one step
-	}
-	Gsubel=xNew<IssmDouble*>(SLGEOM_NUMLOADS);
-	if(computeelastic){
-		GUsubel=xNew<IssmDouble*>(SLGEOM_NUMLOADS);
-		if(horiz){
-			GNsubel=xNew<IssmDouble*>(SLGEOM_NUMLOADS);
-			GEsubel=xNew<IssmDouble*>(SLGEOM_NUMLOADS);
-		}
-	}
-
-	//Allocate: 
-	for(int l=0;l<SLGEOM_NUMLOADS;l++){
-		int nbar=slgeom->nbar[l];
-		Gsubel[l]=xNewZeroInit<IssmDouble>(3*nbar*nt);
-		if(computeelastic){
-			GUsubel[l]=xNewZeroInit<IssmDouble>(3*nbar*nt);
-			if(horiz){
-				GNsubel[l]=xNewZeroInit<IssmDouble>(3*nbar*nt);
-				GEsubel[l]=xNewZeroInit<IssmDouble>(3*nbar*nt);
-			}
-		}
-
-		for(int e=0;e<nbar;e++){
-			ratioe=constant*slgeom->area_subel[l][e];
-			for (int i=0;i<3;i++){
-				IssmDouble alpha;
-				IssmDouble delPhi,delLambda;
-				/*recover info for this element and vertex:*/
-				IssmDouble late= slgeom->latbarycentre[l][e]; 
-				IssmDouble longe= slgeom->longbarycentre[l][e]; 
-				late=late/180*M_PI;
-				longe=longe/180*M_PI;
-
-				lati=latitude[i];
-				longi=longitude[i];
-
-				if(horiz){
-					/*Compute azimuths, both north and east components: */
-					x = xyz_list[i][0]; y = xyz_list[i][1]; z = xyz_list[i][2];
-					if(lati==90){
-						x=1e-12; y=1e-12;
-					}
-					if(lati==-90){
-						x=1e-12; y=1e-12;
-					}
-					IssmDouble xbar=planetradius*cos(late)*cos(longe);
-					IssmDouble ybar=planetradius*cos(late)*sin(longe);
-					IssmDouble zbar=planetradius*sin(late);
-
-					dx = xbar-x; dy = ybar-y; dz = zbar-z;
-					N_azim = (-z*x*dx-z*y*dy+(pow(x,2)+pow(y,2))*dz) /pow((pow(x,2)+pow(y,2))*(pow(x,2)+pow(y,2)+pow(z,2))*(pow(dx,2)+pow(dy,2)+pow(dz,2)),0.5);
-					E_azim = (-y*dx+x*dy) /pow((pow(x,2)+pow(y,2))*(pow(dx,2)+pow(dy,2)+pow(dz,2)),0.5);
-				}
-
-				/*Compute alpha angle between centroid and current vertex and index into precomputed tables: */
-				delPhi=fabs(lati-late); delLambda=fabs(longi-longe); if (delLambda>M_PI)delLambda=2*M_PI-delLambda;
-				alpha=2.*asin(sqrt(pow(sin(delPhi/2.0),2.0)+cos(lati)*cos(late)*pow(sin(delLambda/2.0),2.0)));
-				doubleindex=alpha/M_PI*reCast<IssmDouble,int>(M-1); //maps 0<alpha<PI on [0:M-1]
-				index=reCast<int,IssmDouble>(doubleindex); //truncates doubleindex to integer part
-
-				lincoef=doubleindex-index; //where between index and index+1 is alpha
-				if (index==M-1){ //avoids out of bound case
-					index-=1;
-					lincoef=1;
-				}
-
-				for(int t=0;t<nt;t++){
-					int timeindex=i*nbar*nt+e*nt+t; 
-
-					/*Rigid earth gravitational perturbation: */
-					Gsubel[l][timeindex]+=G_gravi_precomputed[index+0]*(1.-lincoef) 
-					    		     +G_gravi_precomputed[index+1]*lincoef; //linear interpolation
-
-					if(computeelastic){
-						Gsubel[l][timeindex]+=G_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
-								     +G_viscoelastic_precomputed[(index+1)*nt+t]*lincoef; //linear interpolation
-					}
-					Gsubel[l][timeindex]*=ratioe;
-
-					/*Elastic components:*/
-					if(computeelastic){
-						GUsubel[l][timeindex] =  ratioe *(U_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
-										 +U_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
-						if(horiz){
-							GNsubel[l][timeindex] = N_azim*ratioe *(H_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
-								 			      +H_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
-							GEsubel[l][timeindex] = E_azim*ratioe *(H_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
-								 			      +H_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
-						}
-					}
-				}
-			}
-		}
-	}
-
-	/*Save all these arrayins for each element:*/
-	for (int l=0;l<SLGEOM_NUMLOADS;l++){
-		this->inputs->SetArrayInput(slgeom->GEnum(l),this->lid,Gsubel[l],slgeom->nbar[l]*3*nt);
-		if(computeelastic){
-			this->inputs->SetArrayInput(slgeom->GUEnum(l),this->lid,GUsubel[l],slgeom->nbar[l]*3*nt);
-			if(horiz){
-				this->inputs->SetArrayInput(slgeom->GNEnum(l),this->lid,GNsubel[l],slgeom->nbar[l]*3*nt);
-				this->inputs->SetArrayInput(slgeom->GEEnum(l),this->lid,GEsubel[l],slgeom->nbar[l]*3*nt);
-			}
-		}
-	}
-	/*}}}*/
-	/*Free memory:{{{*/
-	for (int l=0;l<SLGEOM_NUMLOADS;l++){
-		xDelete<IssmDouble>(Gsubel[l]);
-		if(computeelastic){
-			xDelete<IssmDouble>(GUsubel[l]);
-			if(horiz){
-				xDelete<IssmDouble>(GNsubel[l]);
-				xDelete<IssmDouble>(GEsubel[l]);
-			}
-		}
-	}
-	xDelete<IssmDouble*>(Gsubel);
-	if(computeelastic){
-		xDelete<IssmDouble*>(GUsubel);
-		if(horiz){
-			xDelete<IssmDouble*>(GNsubel); 
-			xDelete<IssmDouble*>(GEsubel);
-		}
-	}
-	/*}}}*/
-	return;
-
-}
-/*}}}*/
 void       Tria::SealevelchangeUpdateViscousFields(IssmDouble lincoeff, int newindex, int offset){ /*{{{*/
 
@@ -7282,5 +7202,5 @@
 	IssmDouble* viscousE=NULL;
 	int         viscousnumsteps;
-	int         dummy;
+	int         size;
 	bool        viscous=false;
 	int	    horiz=0;
@@ -7292,9 +7212,9 @@
 		this->parameters->FindParam(&viscousnumsteps,SealevelchangeViscousNumStepsEnum);
 
-		this->inputs->GetArrayPtr(SealevelchangeViscousRSLEnum,this->lid,&viscousRSL,&dummy);
-		this->inputs->GetArrayPtr(SealevelchangeViscousUEnum,this->lid,&viscousU,&dummy);
+		this->inputs->GetArrayPtr(SealevelchangeViscousRSLEnum,this->lid,&viscousRSL,&size);
+		this->inputs->GetArrayPtr(SealevelchangeViscousUEnum,this->lid,&viscousU,&size);
 		if(horiz){
-			this->inputs->GetArrayPtr(SealevelchangeViscousNEnum,this->lid,&viscousN,&dummy);
-			this->inputs->GetArrayPtr(SealevelchangeViscousEEnum,this->lid,&viscousE,&dummy);
+			this->inputs->GetArrayPtr(SealevelchangeViscousNEnum,this->lid,&viscousN,&size);
+			this->inputs->GetArrayPtr(SealevelchangeViscousEEnum,this->lid,&viscousE,&size);
 		}
 
@@ -7307,90 +7227,40 @@
 			}
 		}
-
-	}
-
-}
-/*}}}*/
-void       Tria::SealevelchangeBarystaticLoads(GrdLoads* loads,  BarystaticContributions* barycontrib, SealevelGeometry* slgeom){ /*{{{*/
-
-	int nel;
-
-	/*Inputs:*/
-	IssmDouble I[NUMVERTICES]; 
-	IssmDouble W[NUMVERTICES];
-	IssmDouble BP[NUMVERTICES];
-	IssmDouble* areae=NULL;
-
-	/*output: */
-	IssmDouble bslcice=0;
-	IssmDouble bslchydro=0;
-	IssmDouble bslcbp=0;
-	IssmDouble BPavg=0;
-	IssmDouble Iavg=0;
-	IssmDouble Wavg=0;
-
-	/*ice properties: */
-	IssmDouble rho_ice,rho_water,rho_freshwater;
-
-	/*recover some parameters:*/
-	this->parameters->FindParam(&rho_ice,MaterialsRhoIceEnum);
+	}
+}
+/*}}}*/
+void       Tria::SealevelchangeOceanAverage(GrdLoads* loads, Vector<IssmDouble>* oceanareas, Vector<IssmDouble>* subelementoceanareas, IssmDouble* sealevelpercpu, SealevelGeometry* slgeom){ /*{{{*/
+
+	IssmDouble oceanaverage=0;
+	IssmDouble oceanarea=0;
+	IssmDouble rho_water;
+
 	this->parameters->FindParam(&rho_water,MaterialsRhoSeawaterEnum);
-	this->parameters->FindParam(&rho_freshwater,MaterialsRhoFreshwaterEnum);
-	this->parameters->FindParam(&areae,&nel,AreaeEnum);
-
-	/*Retrieve inputs:*/
-	Element::GetInputListOnVertices(&I[0],DeltaIceThicknessEnum);
-	Element::GetInputListOnVertices(&W[0],DeltaTwsEnum);
-	Element::GetInputListOnVertices(&BP[0],DeltaBottomPressureEnum);
-
+
+	/*retrieve ocean average and area:*/
 	for(int i=0;i<NUMVERTICES;i++){
-		Iavg+=I[i]*slgeom->LoadWeigths[SLGEOM_ICE][i][this->lid];
-		Wavg+=W[i]*slgeom->LoadWeigths[SLGEOM_WATER][i][this->lid];
-		BPavg+=BP[i]*slgeom->LoadWeigths[SLGEOM_OCEAN][i][this->lid];
-	}
-
-	/*convert from m to kg/m^2:*/
-	Iavg*=rho_ice;
-	Wavg*=rho_freshwater;
-	BPavg*=rho_water;
-
+		oceanaverage+=sealevelpercpu[this->vertices[i]->lid]*slgeom->LoadWeigths[SLGEOM_OCEAN][i][this->lid];
+	}
 	#ifdef _ISSM_DEBUG_ 
-	this->AddInput(SealevelBarystaticIceLoadEnum,&Iavg,P0Enum);
-	this->AddInput(SealevelBarystaticHydroLoadEnum,&Wavg,P0Enum);
-	this->AddInput(SealevelBarystaticBpLoadEnum,&BPavg,P0Enum);
+	this->AddInput(SealevelBarystaticOceanLoadEnum,&oceanaverage,P0Enum);
 	#endif
-
-	/*Compute barystatic component in kg:*/
-	// Note: Iavg, etc, already include partial area factor phi for subelement loading
-	bslcice =   -slgeom->LoadArea[SLGEOM_ICE][this->lid]*Iavg;
-	bslchydro = -slgeom->LoadArea[SLGEOM_WATER][this->lid]*Wavg;
-	bslcbp =    -slgeom->LoadArea[SLGEOM_OCEAN][this->lid]*BPavg;
-
-	_assert_(!xIsNan<IssmDouble>(bslcice));
-	_assert_(!xIsNan<IssmDouble>(bslchydro));
-	_assert_(!xIsNan<IssmDouble>(bslcbp));
-
-	/*Plug values into subelement load vector:*/
-	if(slgeom->issubelement[SLGEOM_ICE][this->lid]){
-		int intj=slgeom->subelementmapping[SLGEOM_ICE][this->lid];
-		loads->vsubloads[SLGEOM_ICE]->SetValue(intj,Iavg,INS_VAL);
-		Iavg=0; //avoid double counting centroid loads and subelement loads!
-	}
-	if(slgeom->issubelement[SLGEOM_WATER][this->lid]){
-		int intj=slgeom->subelementmapping[SLGEOM_WATER][this->lid];
-		loads->vsubloads[SLGEOM_WATER]->SetValue(intj,Wavg,INS_VAL);
-		Wavg=0;
-	}
+	oceanarea=slgeom->LoadArea[SLGEOM_OCEAN][this->lid];
+
+	/*add ocean average in the global sealevelloads vector:*/
 	if(slgeom->issubelement[SLGEOM_OCEAN][this->lid]){
 		int intj=slgeom->subelementmapping[SLGEOM_OCEAN][this->lid];
-		loads->vsubloads[SLGEOM_OCEAN]->SetValue(intj,BPavg,INS_VAL); 
-		BPavg=0;
-	}
-	/*Plug remaining values into centroid load vector:*/
-	loads->vloads->SetValue(this->sid,Iavg+Wavg+BPavg,INS_VAL);
-
-	/*Keep track of barystatic contributions:*/
-	barycontrib->Set(this->Sid(),bslcice,bslchydro,bslcbp);
-
+		loads->vsubsealevelloads->SetValue(intj,oceanaverage*rho_water*oceanarea,INS_VAL);
+		loads->vsealevelloads->SetValue(this->sid,0.,INS_VAL);
+	}
+	else loads->vsealevelloads->SetValue(this->sid,oceanaverage*rho_water*oceanarea,INS_VAL);
+
+	/*add ocean area into a global oceanareas vector:*/
+	if(!loads->sealevelloads){
+		oceanareas->SetValue(this->sid,oceanarea,INS_VAL);
+		if(slgeom->issubelement[SLGEOM_OCEAN][this->lid]){
+			int intj=slgeom->subelementmapping[SLGEOM_OCEAN][this->lid];
+			subelementoceanareas->SetValue(intj,oceanarea,INS_VAL);
+		}
+	}
 }
 /*}}}*/
@@ -7398,8 +7268,11 @@
 
 	/*sal green function:*/
+	int* AlphaIndex=NULL;
+	int* AlphaIndexsub[SLGEOM_NUMLOADS];
 	IssmDouble* G=NULL;
 	IssmDouble* Grot=NULL;
-	IssmDouble* Gsub[SLGEOM_NUMLOADS];
+	DoubleVecParam* parameter;
 	bool computefuture=false;
+	int spatial_component=0;
 
 	bool sal = false;
@@ -7417,47 +7290,12 @@
 
 	if(sal){
-		this->inputs->GetArrayPtr(SealevelchangeGEnum,this->lid,&G,&size);
-		this->inputs->GetArrayPtr(SealevelchangeGsubelIceEnum,this->lid,&Gsub[SLGEOM_ICE],&size);
-		this->inputs->GetArrayPtr(SealevelchangeGsubelHydroEnum,this->lid,&Gsub[SLGEOM_WATER],&size);
-		this->inputs->GetArrayPtr(SealevelchangeGsubelOceanEnum,this->lid,&Gsub[SLGEOM_OCEAN],&size);
+		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeGViscoElasticEnum)); _assert_(parameter);
+		parameter->GetParameterValueByPointer((IssmDouble**)&G,NULL);
+
+		this->inputs->GetIntArrayPtr(SealevelchangeAlphaIndexEnum,this->lid,&AlphaIndex,&size);
+		for (int l=0;l<SLGEOM_NUMLOADS;l++) this->inputs->GetIntArrayPtr(slgeom->AlphaIndexEnum(l),this->lid,&AlphaIndexsub[l],&size);
 		if (rotation)	this->inputs->GetArrayPtr(SealevelchangeGrotEnum,this->lid,&Grot,&size);
 
-		this->SealevelchangeGxL(sealevelpercpu, G, Gsub, Grot, loads, polarmotionvector, slgeom, nel,percpu=true,SealevelchangeViscousRSLEnum,computefuture=false);
-	}
-
-	return;
-} /*}}}*/
-void       Tria::SealevelchangeOceanAverage(GrdLoads* loads, Vector<IssmDouble>* oceanareas, Vector<IssmDouble>* subelementoceanareas, IssmDouble* sealevelpercpu, SealevelGeometry* slgeom){ /*{{{*/
-
-	IssmDouble oceanaverage=0;
-	IssmDouble oceanarea=0;
-	IssmDouble rho_water;
-
-	this->parameters->FindParam(&rho_water,MaterialsRhoSeawaterEnum);
-
-	/*retrieve ocean average and area:*/
-	for(int i=0;i<NUMVERTICES;i++){
-		oceanaverage+=sealevelpercpu[this->vertices[i]->lid]*slgeom->LoadWeigths[SLGEOM_OCEAN][i][this->lid];
-	}
-	#ifdef _ISSM_DEBUG_ 
-	this->AddInput(SealevelBarystaticOceanLoadEnum,&oceanaverage,P0Enum);
-	#endif
-	oceanarea=slgeom->LoadArea[SLGEOM_OCEAN][this->lid];
-
-	/*add ocean average in the global sealevelloads vector:*/
-	if(slgeom->issubelement[SLGEOM_OCEAN][this->lid]){
-		int intj=slgeom->subelementmapping[SLGEOM_OCEAN][this->lid];
-		loads->vsubsealevelloads->SetValue(intj,oceanaverage*rho_water,INS_VAL);
-		loads->vsealevelloads->SetValue(this->sid,0.,INS_VAL);
-	}
-	else loads->vsealevelloads->SetValue(this->sid,oceanaverage*rho_water,INS_VAL);
-
-	/*add ocean area into a global oceanareas vector:*/
-	if(!loads->sealevelloads){
-		oceanareas->SetValue(this->sid,oceanarea,INS_VAL);
-		if(slgeom->issubelement[SLGEOM_OCEAN][this->lid]){
-			int intj=slgeom->subelementmapping[SLGEOM_OCEAN][this->lid];
-			subelementoceanareas->SetValue(intj,oceanarea,INS_VAL);
-		}
+		this->SealevelchangeGxL(sealevelpercpu, spatial_component=0,AlphaIndex, AlphaIndexsub, NULL, NULL, G, Grot, loads, polarmotionvector, slgeom, nel,percpu=true,SealevelchangeViscousRSLEnum,computefuture=false);
 	}
 
@@ -7473,16 +7311,18 @@
 	int nel,nbar;
 	bool sal = false;
+	int* AlphaIndex=NULL;
+	int* AzimIndex=NULL;
+	int* AlphaIndexsub[SLGEOM_NUMLOADS];
+	int* AzimIndexsub[SLGEOM_NUMLOADS];
+	int spatial_component=0;
 	IssmDouble* G=NULL;
 	IssmDouble* GU=NULL;
-	IssmDouble* GE=NULL;
-	IssmDouble* GN=NULL;
+	IssmDouble* GH=NULL;
 	IssmDouble* Grot=NULL;
 	IssmDouble* GUrot=NULL;
 	IssmDouble* GNrot=NULL;
 	IssmDouble* GErot=NULL;
-	IssmDouble* Gsub[SLGEOM_NUMLOADS];
-	IssmDouble* GUsub[SLGEOM_NUMLOADS];
-	IssmDouble* GNsub[SLGEOM_NUMLOADS];
-	IssmDouble* GEsub[SLGEOM_NUMLOADS];
+
+	DoubleVecParam* parameter;
 	bool computefuture=false;
 
@@ -7503,25 +7343,20 @@
 
 	if(sal){
-
-		this->inputs->GetArrayPtr(SealevelchangeGEnum,this->lid,&G,&size);
-		this->inputs->GetArrayPtr(SealevelchangeGsubelIceEnum,this->lid,&Gsub[SLGEOM_ICE],&size);
-		this->inputs->GetArrayPtr(SealevelchangeGsubelHydroEnum,this->lid,&Gsub[SLGEOM_WATER],&size);
-		this->inputs->GetArrayPtr(SealevelchangeGsubelOceanEnum,this->lid,&Gsub[SLGEOM_OCEAN],&size);
+		this->inputs->GetIntArrayPtr(SealevelchangeAlphaIndexEnum,this->lid,&AlphaIndex,&size);
+		for (int l=0;l<SLGEOM_NUMLOADS;l++) this->inputs->GetIntArrayPtr(slgeom->AlphaIndexEnum(l),this->lid,&AlphaIndexsub[l],&size);
+
+		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeGViscoElasticEnum)); _assert_(parameter);
+		parameter->GetParameterValueByPointer((IssmDouble**)&G,NULL);
 
 		if(elastic){
-			this->inputs->GetArrayPtr(SealevelchangeGUEnum,this->lid,&GU,&size);
-			this->inputs->GetArrayPtr(SealevelchangeGUsubelIceEnum,this->lid,&GUsub[SLGEOM_ICE],&size);
-			this->inputs->GetArrayPtr(SealevelchangeGUsubelHydroEnum,this->lid,&GUsub[SLGEOM_WATER],&size);
-			this->inputs->GetArrayPtr(SealevelchangeGUsubelOceanEnum,this->lid,&GUsub[SLGEOM_OCEAN],&size);
+			parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeUViscoElasticEnum)); _assert_(parameter);
+			parameter->GetParameterValueByPointer((IssmDouble**)&GU,NULL);
+
 			if(horiz){
-				this->inputs->GetArrayPtr(SealevelchangeGNEnum,this->lid,&GN,&size);
-				this->inputs->GetArrayPtr(SealevelchangeGNsubelIceEnum,this->lid,&GNsub[SLGEOM_ICE],&size);
-				this->inputs->GetArrayPtr(SealevelchangeGNsubelHydroEnum,this->lid,&GNsub[SLGEOM_WATER],&size);
-				this->inputs->GetArrayPtr(SealevelchangeGNsubelOceanEnum,this->lid,&GNsub[SLGEOM_OCEAN],&size);
-
-				this->inputs->GetArrayPtr(SealevelchangeGEEnum,this->lid,&GE,&size);
-				this->inputs->GetArrayPtr(SealevelchangeGEsubelIceEnum,this->lid,&GEsub[SLGEOM_ICE],&size);
-				this->inputs->GetArrayPtr(SealevelchangeGEsubelHydroEnum,this->lid,&GEsub[SLGEOM_WATER],&size);
-				this->inputs->GetArrayPtr(SealevelchangeGEsubelOceanEnum,this->lid,&GEsub[SLGEOM_OCEAN],&size);
+				this->inputs->GetIntArrayPtr(SealevelchangeAzimuthIndexEnum,this->lid,&AzimIndex,&size);
+				for (int l=0;l<SLGEOM_NUMLOADS;l++) this->inputs->GetIntArrayPtr(slgeom->AzimuthIndexEnum(l),this->lid,&AzimIndexsub[l],&size);
+
+				parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeHViscoElasticEnum)); _assert_(parameter);
+				parameter->GetParameterValueByPointer((IssmDouble**)&GH,NULL);
 			}
 			if (rotation) {
@@ -7534,11 +7369,12 @@
 			}
 		}
-		this->SealevelchangeGxL(&RSLGrd[0],G, Gsub, Grot, loads, polarmotionvector, slgeom, nel,percpu=false,SealevelchangeViscousRSLEnum,computefuture=true);
+
+		this->SealevelchangeGxL(&RSLGrd[0],spatial_component=0, AlphaIndex, AlphaIndexsub,NULL, NULL,G, Grot, loads, polarmotionvector, slgeom, nel,percpu=false,SealevelchangeViscousRSLEnum,computefuture=true);
 
 		if(elastic){
-			this->SealevelchangeGxL(&UGrd[0],GU, GUsub, GUrot, loads, polarmotionvector, slgeom, nel,percpu=false,SealevelchangeViscousUEnum,computefuture=true);
+			this->SealevelchangeGxL(&UGrd[0],spatial_component=0, AlphaIndex, AlphaIndexsub,NULL, NULL, GU, GUrot, loads, polarmotionvector, slgeom, nel,percpu=false,SealevelchangeViscousUEnum,computefuture=true);
 			if(horiz){
-				this->SealevelchangeGxL(&NGrd[0],GN, GNsub, GNrot, loads, polarmotionvector, slgeom, nel,percpu=false,SealevelchangeViscousNEnum,computefuture=true);
-				this->SealevelchangeGxL(&EGrd[0],GE, GEsub, GErot, loads, polarmotionvector, slgeom, nel,percpu=false,SealevelchangeViscousEEnum,computefuture=true);
+				this->SealevelchangeGxL(&NGrd[0],spatial_component=1,AlphaIndex, AlphaIndexsub,AzimIndex,AzimIndexsub,GH, GNrot, loads, polarmotionvector, slgeom, nel,percpu=false,SealevelchangeViscousNEnum,computefuture=true);
+				this->SealevelchangeGxL(&EGrd[0],spatial_component=2,AlphaIndex, AlphaIndexsub,AzimIndex,AzimIndexsub,GH, GErot, loads, polarmotionvector, slgeom, nel,percpu=false,SealevelchangeViscousEEnum,computefuture=true);
 			}
 		}
@@ -7565,16 +7401,29 @@
 
 } /*}}}*/
-void       Tria::SealevelchangeGxL(IssmDouble* grdfieldout, IssmDouble* G, IssmDouble** Gsub, IssmDouble* Grot, GrdLoads* loads, IssmDouble* polarmotionvector, SealevelGeometry* slgeom, int nel, bool percpu, int viscousenum, bool computefuture) { /*{{{*/
+void       Tria::SealevelchangeGxL(IssmDouble* grdfieldout, int spatial_component, int* AlphaIndex, int** AlphaIndexsub, int* AzimIndex, int**AzimIndexsub, IssmDouble* G, IssmDouble* Grot, GrdLoads* loads, IssmDouble* polarmotionvector, SealevelGeometry* slgeom, int nel, bool percpu, int viscousenum, bool computefuture) { /*{{{*/
 
 	//This function performs the actual convolution between Green functions and surface Loads for a particular grd field
 
 	IssmDouble* grdfield=NULL;
-	int i,e,l,t,nbar;
+	int i,e,l,t,a, index, nbar;
+	bool rotation=false;
+	IssmDouble* Centroid_loads=NULL;
+	IssmDouble* Centroid_loads_copy=NULL;
+	IssmDouble* Subelement_loads[SLGEOM_NUMLOADS];
+	IssmDouble* Subelement_loads_copy[SLGEOM_NUMLOADS];
+	IssmDouble* horiz_projection=NULL;
+	IssmDouble* horiz_projectionsub[SLGEOM_NUMLOADS];
+	int nt=1; //important, ensures there is a defined value if computeviscous is false
+
+	//viscous
 	bool computeviscous=false;
-	bool rotation=false;
-	IssmDouble* viscousfield=NULL;
-	int nt=1; //important, ensures there is a defined value if computeviscous is false
 	int viscousindex=0; //important
 	int viscousnumsteps=1; //important
+	IssmDouble* viscousfield=NULL;
+	IssmDouble* grdfieldinterp=NULL;
+	IssmDouble* viscoustimes=NULL;
+	IssmDouble  final_time;
+	IssmDouble  lincoeff;
+	IssmDouble  timeacc;
 
 	this->parameters->FindParam(&computeviscous,SolidearthSettingsViscousEnum);
@@ -7583,7 +7432,12 @@
 		this->parameters->FindParam(&viscousnumsteps,SealevelchangeViscousNumStepsEnum);
 		this->parameters->FindParam(&viscousindex,SealevelchangeViscousIndexEnum);
+		this->parameters->FindParam(&viscoustimes,NULL,SealevelchangeViscousTimesEnum);
+		this->parameters->FindParam(&final_time,TimesteppingFinalTimeEnum);
+		this->parameters->FindParam(&timeacc,SolidearthSettingsTimeAccEnum);
+		this->inputs->GetArrayPtr(viscousenum,this->lid,&viscousfield,NULL);
 		if(computefuture) {
 			nt=viscousnumsteps-viscousindex+2; //number of time steps remaining to reach final_time, +1 is sufficient with no adaptative time stepping, +2 necessary otherwise; we assume the safe choice here for the sake of simplicity
 			if (nt>viscousnumsteps) nt=viscousnumsteps;
+			grdfieldinterp=xNewZeroInit<IssmDouble>(3*viscousnumsteps); 
 		}
 		else nt=1;
@@ -7605,53 +7459,101 @@
 	}
 
-
-	if(loads->sealevelloads){ // general case: loads + sealevel loads
-		for(i=0;i<NUMVERTICES;i++) {
-			if(slgeom->lids[this->vertices[i]->lid]!=this->lid)continue;
-			for (e=0;e<nel;e++){
-				for(t=0;t<nt;t++){
-					int index=i*nel*viscousnumsteps+e*viscousnumsteps+t;
-					grdfield[i*nt+t]+=G[index]*(loads->sealevelloads[e]+loads->loads[e]);
+	//Determine loads /*{{{*/
+	Centroid_loads=xNewZeroInit<IssmDouble>(nel);
+	for (e=0;e<nel;e++){
+		Centroid_loads[e]=loads->loads[e];
+	}
+	for(l=0;l<SLGEOM_NUMLOADS;l++){
+		nbar=slgeom->nbar[l];
+		Subelement_loads[l]=xNewZeroInit<IssmDouble>(nbar);
+		for (e=0;e<nbar;e++){
+			Subelement_loads[l][e]=(loads->subloads[l][e]);
+		}
+	}
+	if(loads->sealevelloads){
+		for (e=0;e<nel;e++){
+			Centroid_loads[e]+=(loads->sealevelloads[e]);
+		}
+		nbar=slgeom->nbar[SLGEOM_OCEAN];
+		for (e=0;e<nbar;e++){
+			Subelement_loads[SLGEOM_OCEAN][e]+=(loads->subsealevelloads[e]);
+		}
+	}
+
+	//Copy loads if dealing with a horizontal component: the result will need to be projected against the North or East axis for each vertex
+	if (spatial_component!=0){
+		horiz_projection=xNewZeroInit<IssmDouble>(3*nel);
+		Centroid_loads_copy=xNewZeroInit<IssmDouble>(nel);
+		for (e=0;e<nel;e++){
+			Centroid_loads_copy[e]=Centroid_loads[e];
+		}
+
+		for(l=0;l<SLGEOM_NUMLOADS;l++){
+			nbar=slgeom->nbar[l];
+			Subelement_loads_copy[l]=xNewZeroInit<IssmDouble>(nbar);
+			horiz_projectionsub[l]=xNewZeroInit<IssmDouble>(3*nbar);
+			for (e=0;e<nbar;e++){
+				Subelement_loads_copy[l][e]=Subelement_loads[l][e];
+			}
+		}
+	}
+	/*}}}*/
+
+	//Convolution
+	for(i=0;i<NUMVERTICES;i++) { /*{{{*/
+		if(slgeom->lids[this->vertices[i]->lid]!=this->lid)continue;
+
+		if (spatial_component!=0){ //horizontals /*{{{*/
+			//GxL needs to be projected on the right axis before summation into the grd field
+			//here we apply the projection scalar to the load prior to the actual convolution loop for more efficiency
+			if (spatial_component==1){ //north
+				for (e=0;e<nel;e++){
+					horiz_projection[i*nel+e]=cos(2.0*M_PI*reCast<IssmDouble,int>(AzimIndex[i*nel+e])/65535.0); // 65535=2^16-1 = max value of 16 bits unsigned int
 				}
-			}
+				for(l=0;l<SLGEOM_NUMLOADS;l++){
+					nbar=slgeom->nbar[l];
+					for (e=0;e<nbar;e++){
+						horiz_projectionsub[l][i*nbar+e]=cos(2.0*M_PI*reCast<IssmDouble,int>(AzimIndexsub[l][i*nbar+e])/65535.0);;
+					}
+				}
+			}
+			else if (spatial_component==2){ //east
+				for (e=0;e<nel;e++){
+					horiz_projection[i*nel+e]=sin(2.0*M_PI*reCast<IssmDouble,int>(AzimIndex[i*nel+e])/65535.0);
+				}
+				for(l=0;l<SLGEOM_NUMLOADS;l++){
+					nbar=slgeom->nbar[l];
+					for (e=0;e<nbar;e++){
+						horiz_projectionsub[l][i*nbar+e]=sin(2.0*M_PI*reCast<IssmDouble,int>(AzimIndexsub[l][i*nbar+e])/65535.0);;
+					}
+				}
+			}
+			for (e=0;e<nel;e++) Centroid_loads[e]=Centroid_loads_copy[e]*horiz_projection[i*nel+e];
 			for(l=0;l<SLGEOM_NUMLOADS;l++){
 				nbar=slgeom->nbar[l];
 				for (e=0;e<nbar;e++){
-					for(t=0;t<nt;t++){
-						int index=i*nbar*viscousnumsteps+e*viscousnumsteps+t;
-						grdfield[i*nt+t]+=Gsub[l][index]*(loads->subloads[l][e]);
-					}
+					Subelement_loads[l][e]=Subelement_loads_copy[l][e]*horiz_projectionsub[l][i*nbar+e];
 				}
-				if(l==SLGEOM_OCEAN){
-					for (e=0;e<nbar;e++){
-						for(t=0;t<nt;t++){
-							int index=i*nbar*viscousnumsteps+e*viscousnumsteps+t;
-							grdfield[i*nt+t]+=Gsub[l][index]*(loads->subsealevelloads[e]);
-						}
-					}
+			}
+		} /*}}}*/
+
+		for (e=0;e<nel;e++){
+			for(t=0;t<nt;t++){
+				a=AlphaIndex[i*nel+e];
+				grdfield[i*nt+t]+=G[a*viscousnumsteps+t]*Centroid_loads[e];
+			}
+		}
+		for(l=0;l<SLGEOM_NUMLOADS;l++){
+			nbar=slgeom->nbar[l];
+			for (e=0;e<nbar;e++){
+				for(t=0;t<nt;t++){
+					a=AlphaIndexsub[l][i*nbar+e];
+					grdfield[i*nt+t]+=G[a*viscousnumsteps+t]*Subelement_loads[l][e];
 				}
 			}
 		}
-	}
-	else{  //this is the initial convolution where only loads are provided
-		for(i=0;i<NUMVERTICES;i++) {
-			if(slgeom->lids[this->vertices[i]->lid]!=this->lid)continue;
-			for (e=0;e<nel;e++){
-				for(t=0;t<nt;t++){
-					int index=i*nel*viscousnumsteps+e*viscousnumsteps+t;
-					grdfield[i*nt+t]+=G[index]*(loads->loads[e]);
-				}
-			}
-			for(l=0;l<SLGEOM_NUMLOADS;l++){
-				nbar=slgeom->nbar[l];
-				for (e=0;e<nbar;e++){
-					for(t=0;t<nt;t++){
-						int index=i*nbar*viscousnumsteps+e*viscousnumsteps+t;
-						grdfield[i*nt+t]+=Gsub[l][index]*(loads->subloads[l][e]);
-					}
-				}
-			}
-		}
-	}
+	} /*}}}*/
+
+
 
 	if(computeviscous){ /*{{{*/
@@ -7661,17 +7563,6 @@
 		// 3*: subtract from viscous stack the grdfield that has already been accounted for so we don't add it again at the next time step
 
-		IssmDouble* grdfieldinterp=NULL;
-		IssmDouble* viscoustimes=NULL;
-		IssmDouble  final_time;
-		IssmDouble  lincoeff;
-		IssmDouble  timeacc;
-
-		this->parameters->FindParam(&viscoustimes,NULL,SealevelchangeViscousTimesEnum);
-		this->parameters->FindParam(&final_time,TimesteppingFinalTimeEnum);
-		this->parameters->FindParam(&timeacc,SolidearthSettingsTimeAccEnum);
-		this->inputs->GetArrayPtr(viscousenum,this->lid,&viscousfield,NULL);
 		/* Map new grdfield generated by present-day loads onto viscous time vector*/
 		if(computefuture){
-			grdfieldinterp=xNewZeroInit<IssmDouble>(3*viscousnumsteps); 
 			//viscousindex time and first time step of grdfield coincide, so just copy that value
 			for(int i=0;i<NUMVERTICES;i++){
@@ -7685,5 +7576,6 @@
 					for(int i=0;i<NUMVERTICES;i++){
 						if(slgeom->lids[this->vertices[i]->lid]!=this->lid)continue;
-						grdfieldinterp[i*viscousnumsteps+t]=  (1-lincoeff)*grdfield[i*nt+(t-viscousindex-1)]+lincoeff*grdfield[i*nt+(t-viscousindex)];
+						grdfieldinterp[i*viscousnumsteps+t] = (1-lincoeff)*grdfield[i*nt+(t-viscousindex-1)]
+											 +lincoeff*grdfield[i*nt+(t-viscousindex)];
 					}
 				}
@@ -7699,17 +7591,19 @@
 		/*update viscous stack with future deformation from present load: */
 		if(computefuture){
-			for(int t=viscousnumsteps-1;t>=viscousindex;t--){
+			for(int t=viscousnumsteps-1;t>=viscousindex;t--){ //we need to go backwards so as not to zero out viscousfield[i*viscousnumsteps+viscousindex] until the end
 				for(int i=0;i<NUMVERTICES;i++){
 					if(slgeom->lids[this->vertices[i]->lid]!=this->lid)continue;
 					//offset viscousfield to remove all deformation that has already been added
-					viscousfield[i*viscousnumsteps+t]+=grdfieldinterp[i*viscousnumsteps+t]-grdfieldinterp[i*viscousnumsteps+viscousindex]-viscousfield[i*viscousnumsteps+viscousindex];
+					viscousfield[i*viscousnumsteps+t]+=grdfieldinterp[i*viscousnumsteps+t]
+									  -grdfieldinterp[i*viscousnumsteps+viscousindex]
+									  -viscousfield[i*viscousnumsteps+viscousindex];
 				}
 			}
 			/*Save viscous stack now that we updated the values:*/
 			this->inputs->SetArrayInput(viscousenum,this->lid,viscousfield,3*viscousnumsteps);
-		}
-
-		/*Free allocatoins:*/
-		xDelete<IssmDouble>(viscoustimes);
+
+			/*Free resources:*/
+			xDelete<IssmDouble>(grdfieldinterp);
+		}
 	} 
 	/*}}}*/
